
%define name		fglrx-hd2000

# %atibuild is used to enable special mode for the ATI installer.
# The macros version, rel, ati_dir, distsuffix need to be manually defined.
# The macro mdkversion can also be overridden.
%define atibuild	0
%{?_without_ati: %global atibuild 0}
%{?_with_ati: %global atibuild 1}

%if !%{atibuild}
# defined by ati-packager.sh when using ati installer
%define version		8.41.7
%define subrel		1
%define rel		3
%endif

%define priority	900
%define release %mkrel %{rel}

%define driverpkgname	x11-driver-video-fglrx-hd2000
%define drivername	fglrx-hd2000
%define xorg_version	710
%define xorg_libdir	%{_libdir}/xorg
%define xorg_includedir	%{_includedir}
%define ld_so_conf_dir	%{_sysconfdir}/ld.so.conf.d/GL
%define ld_so_conf_file	ati-hd2000.conf
%define ati_sysconfdir	%{_sysconfdir}/%{drivername}
%define ati_bindir	%{_libdir}/%{drivername}/bin
%define ati_sbindir	%{_libdir}/%{drivername}/bin
%define ati_modulesdir	%{_libdir}/%{drivername}/modules
%define ati_driversdir	%{xorg_libdir}/modules/drivers/%{drivername}
%define ati_desktopdir	%{_datadir}/%{drivername}-desktop
%define ati_datadir	%{_datadir}/%{drivername}

%if %{mdkversion} <= 200710
%define driverpkgname	ati
%define drivername	ati
%define ati_sysconfdir	%{_sysconfdir}/ati
%define ati_sbindir	%{_sbindir}
%define ati_bindir	%{_bindir}
%define ati_modulesdir	%{xorg_libdir}/modules
%define ati_driversdir	%{xorg_libdir}/modules/drivers
%define ati_desktopdir	%{_datadir}/applications
%define ati_datadir	%{_datadir}/ati
%define ld_so_conf_file	ati.conf
%endif

%if %{mdkversion} <= 200600
%define xorg_version	690
%define xorg_libdir	%{_prefix}/X11R6/%{_lib}
%define xorg_includedir	%{_prefix}/X11R6/include
%define ld_so_conf_dir	%{_sysconfdir}/ld.so.conf.d
%endif

%ifarch %ix86
%define xverdir		x%{xorg_version}
%define archdir		arch/x86
%endif
%ifarch x86_64
%define xverdir		x%{xorg_version}_64a
%define archdir		arch/x86_64
%endif

# Other packages should not require any ATI specific proprietary libraries
# (if that is really necessary, we may want to split that specific lib out),
# and this package should not be pulled in when libGL.so.1 is required.
%define _provides_exceptions \\.so
%define common_requires_exceptions libfglrx.\\+\\.so

%ifarch x86_64
# (anssi) Allow installing of 64-bit package if the runtime dependencies
# of 32-bit libraries are not satisfied. If a 32-bit package that requires
# libGL.so.1 is installed, the 32-bit mesa libs are pulled in and that will
# pull the dependencies of 32-bit fglrx libraries in as well.
%define _requires_exceptions %common_requires_exceptions\\|lib.*so\\.[^(]\\+\\(([^)]\\+)\\)\\?$
%else
%define _requires_exceptions %common_requires_exceptions
%endif

Summary:	ATI proprietary X.org driver and libraries for HD 2000 family cards
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	https://a248.e.akamai.net/f/674/9206/0/www2.ati.com/drivers/linux/ati-driver-installer-%{version}-x86.x86_64.run
Source1:	ati-packager.sh
Source2:	atieventsd-hd2000.init
Patch0:		ati-8.32.5-uname_r.patch
Patch1:		ati-8.19.10-fglrx_gamma-extutil-include.patch
Patch2:		ati-8.19.10-fgl_glxgears-includes.patch
License:	Proprietary
URL:		http://ati.amd.com/support/driver.html
Group:		System/Kernel and hardware
ExclusiveArch:	%{ix86} x86_64
BuildRoot:	%{_tmppath}/%{name}-root
%if !%{atibuild}
%if %{mdkversion} <= 200600
BuildRequires:	MesaGLU-devel
%else
# TODO: Check which ones are not needed as control panel is not built anymore:
BuildRequires:	mesaglu-devel
BuildRequires:	mesagl-devel
BuildRequires:	libxmu-devel
BuildRequires:	libxinerama-devel
BuildRequires:	libxrender-devel
BuildRequires:	libxft-devel
BuildRequires:	libxaw-devel
BuildRequires:	imake
BuildRequires:	x11-util-cf-files
%endif
BuildRequires:	ImageMagick
%endif

%description
Source package of the ATI proprietary driver HD 2000 family cards. Binary
packages are named x11-driver-video-fglrx-hd2000 on Mandriva Linux 2008, and ati
on 2007 and earlier.

%package -n %{driverpkgname}
Summary:	ATI proprietary X.org driver and libraries for HD 2000 family cards
Group:		System/Kernel and hardware
%if %{mdkversion} >= 200700
Requires(post):	update-alternatives >= 1.9.0
Requires(postun): update-alternatives
%endif
%if %{mdkversion} >= 200800
Suggests:	%{drivername}-control-center = %{version}
Conflicts:	x11-server-common < 1.3.0.0-17
Conflicts:	x11-driver-video-fglrx < 8.40.4-4
Conflicts:	harddrake < 10.4.197
Conflicts:	drakx-kbd-mouse-x11 < 0.26
%endif

%description -n %{driverpkgname}
ATI proprietary X.org graphics driver, related libraries and
configuration tools for HD 2000 family cards.

NOTE: You should use XFdrake to configure your ATI card. The
correct packages will be automatically installed and configured.

If you do not want to use XFdrake, see README.manual-setup.

The graphical configuration utility, AMD Catalyst Control Center
Linux Edition, is contained in the package
%{drivername}-control-center.

%package -n %{drivername}-control-center
Summary:	AMD Catalyst Control Center Linux Edition for HD 2000 family cards
Group:		System/Kernel and hardware

%description -n %{drivername}-control-center
AMD Catalyst Control Center Linux Edition, a graphical configuration
utility for the ATI proprietary X.org driver for HD 2000 family cards.

%package -n dkms-%{drivername}
Summary:	ATI proprietary kernel module for HD 2000 family cards
Group:		System/Kernel and hardware
Requires:	dkms
Requires(post):	dkms
Requires(preun): dkms
Requires:	%{driverpkgname} = %{version}

%description -n dkms-%{drivername}
ATI proprietary kernel module for HD 2000 family cards. This is to be
used with the %{driverpkgname} package.

%package -n %{drivername}-devel
Summary:	ATI proprietary development libraries and headers for HD 2000 family cards
Group:		Development/C
Requires:	%{driverpkgname} = %{version}-%{release}
Conflicts:	fglrx-devel

%description -n %{drivername}-devel
ATI proprietary development libraries and headers. This package is
not required for normal use.

The main driver package name is %{driverpkgname}.

%prep
%setup -T -c
%if %{atibuild}
ln -s %{ati_dir}/%{xverdir} %{ati_dir}/arch .
# patch0 affects common, so we cannot symlink it:
cp -a %{ati_dir}/common .
%else
sh %{SOURCE0} --extract .

mkdir fglrx_tools
tar -xzf common/usr/src/ati/fglrx_sample_source.tgz -C fglrx_tools
cd fglrx_tools # ensure patch does not touch outside
%patch1 -p1
%patch2 -p1
cd -
cmp common/usr/X11R6/include/X11/extensions/fglrx_gamma.h fglrx_tools/lib/fglrx_gamma/fglrx_gamma.h
%endif

cd common # ensure patch does not touch outside
%patch0 -p2
cd -

cat > README.install.urpmi <<EOF
This driver is for ATI Radeon HD 2000 family cards.
Reconfiguring is not necessary when upgrading from a previous Mandriva ATI
driver package.

Use XFdrake to configure X to use the correct ATI driver. Any needed
packages will be automatically installed if not already present.
1. Run XFdrake as root.
2. Go to the Graphics Card list.
3. Select your card (it is usually already autoselected).
4. Answer any questions asked and then quit.

If you do not want to use XFdrake or it does not work correctly for
you, see README.manual-setup for manual installation instructions.
EOF

cat > README.manual-setup <<EOF
This file describes the procedure for the manual installation of this ATI
driver package. You can find the instructions for the recommended automatic
installation in the file 'README.install.urpmi' in this directory.

- Open %{_sysconfdir}/X11/xorg.conf and make the following changes:
  o Change the Driver to "fglrx" in the Device section
  o Make the line below the only 'glx' related line in the Module section:
      Load "glx"
%if %{mdkversion} >= 200710
  o Remove any 'ModulePath' lines from the Files section
%endif
%if %{mdkversion} >= 200700
- Run "update-alternatives --set gl_conf %{ld_so_conf_dir}/%{ld_so_conf_file}" as root.
- Run "ldconfig" as root.
%endif
EOF

%build
%if !%{atibuild}
# %atibuild is done with minimal buildrequires
cd fglrx_tools/lib/fglrx_gamma
xmkmf
%make CC="%__cc %optflags"
cd -
cd fglrx_tools/fgl_glxgears
xmkmf
%make RMAN=/bin/true CC="%__cc %optflags"
cd -
cd fglrx_tools/programs/fglrx_gamma
xmkmf
%make INSTALLED_LIBS=-L../../lib/fglrx_gamma INCLUDES=-I../../../common/usr/X11R6/include CC="%__cc %optflags" RMAN=/bin/true
cd -
%endif

%install
rm -rf %{buildroot}

# dkms
install -d -m755 %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}
cp -a common/lib/modules/fglrx/build_mod/* %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}
cp -a %{archdir}/lib/modules/fglrx/build_mod/* %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}

cat > %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_NAME="%{drivername}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME[0]="fglrx"
%if %{mdkversion} >= 200800
DEST_MODULE_NAME[0]="%{drivername}"
%endif
DEST_MODULE_LOCATION[0]="/kernel/drivers/char/drm"
MAKE[0]="KERNEL_PATH=\${kernel_source_dir} uname_r=\${kernelver} sh make.sh"
AUTOINSTALL="yes"
EOF

# headers
install -d -m755		%{buildroot}%{_includedir}
cp -a common/usr/include/*	%{buildroot}%{_includedir}

install -d -m755 %{buildroot}%{xorg_includedir}/X11/extensions
install -m644 common/usr/X11R6/include/X11/extensions/*.h  %{buildroot}%{xorg_includedir}/X11/extensions

# install binaries
install -d -m755					%{buildroot}%{ati_sbindir}
install -m755 %{archdir}/usr/sbin/atieventsd		%{buildroot}%{ati_sbindir}
install -m755 common/usr/sbin/*				%{buildroot}%{ati_sbindir}
install -d -m755					%{buildroot}%{ati_bindir}
install -m755 %{archdir}/usr/X11R6/bin/aticonfig	%{buildroot}%{ati_bindir}
install -m755 %{archdir}/usr/X11R6/bin/fglrxinfo	%{buildroot}%{ati_bindir}
install -m755 %{archdir}/usr/X11R6/bin/amdcccle		%{buildroot}%{ati_bindir}
%if !%{atibuild}
# install self-built binaries
install -m755 fglrx_tools/fgl_glxgears/fgl_glxgears	%{buildroot}%{ati_bindir}
install -m755 fglrx_tools/programs/fglrx_gamma/fglrx_xgamma %{buildroot}%{ati_bindir}
%else
install -m755 %{archdir}/usr/X11R6/bin/fgl_glxgears	%{buildroot}%{ati_bindir}
install -m755 %{archdir}/usr/X11R6/bin/fglrx_xgamma %{buildroot}%{ati_bindir}
%endif
%if %{mdkversion} >= 200800
install -d -m755	%{buildroot}%{_sbindir}
touch 			%{buildroot}%{_sbindir}/atieventsd
touch 			%{buildroot}%{_sbindir}/atigetsysteminfo.sh
install -d -m755	%{buildroot}%{_bindir}
touch 			%{buildroot}%{_bindir}/aticonfig
touch 			%{buildroot}%{_bindir}/fglrxinfo
touch 			%{buildroot}%{_bindir}/amdcccle
touch 			%{buildroot}%{_bindir}/fgl_glxgears
touch 			%{buildroot}%{_bindir}/fglrx_xgamma
%endif

# atieventsd initscript
install -d -m755 %{buildroot}%{_initrddir}
install -m755 %{SOURCE2} %{buildroot}%{_initrddir}/atieventsd-hd2000

# amdcccle data files
install -d -m755 %{buildroot}%{ati_datadir}/amdcccle
install -m644 common/usr/share/ati/amdcccle/*.qm %{buildroot}%{ati_datadir}/amdcccle
%if %{mdkversion} >= 200800
install -d -m755 %{buildroot}%{_datadir}/ati
%endif

# menu entry
%if %{mdkversion} <= 200600
install -d -m755 %{buildroot}%{_menudir}
cat <<EOF >%{buildroot}%{_menudir}/%{drivername}-control-center
?package(%{drivername}-control-center):command="%{_bindir}/amdcccle" \
                  icon=%{drivername}-amdcccle.png \
                  needs="x11" \
                  section="System/Configuration/Hardware" \
                  title="ATI Catalyst Control Center" \
                  longtitle="ATI graphics adapter settings" \
                  xdg="true"
EOF
%endif

install -d -m755 %{buildroot}%{ati_desktopdir}
cat > %{buildroot}%{ati_desktopdir}/mandriva-amdcccle.desktop << EOF
[Desktop Entry]
Name=ATI Catalyst Control Center
Comment=ATI graphics adapter settings
Exec=%{_bindir}/amdcccle
Icon=%{drivername}-amdcccle
Terminal=false
Type=Application
Categories=Settings;HardwareSettings;X-MandrivaLinux-System-Configuration;
EOF
%if %{mdkversion} >= 200800
install -d -m755 %{buildroot}%{_datadir}/applications
touch %{buildroot}%{_datadir}/applications/mandriva-amdcccle.desktop
%endif

# icons
install -d -m755 %{buildroot}%{_miconsdir} %{buildroot}%{_iconsdir} %{buildroot}%{_liconsdir}
%if !%{atibuild}
convert common/usr/share/icons/ccc_large.xpm -resize 16x16 %{buildroot}%{_miconsdir}/%{drivername}-amdcccle.png
convert common/usr/share/icons/ccc_large.xpm -resize 32x32 %{buildroot}%{_iconsdir}/%{drivername}-amdcccle.png
convert common/usr/share/icons/ccc_large.xpm -resize 48x48 %{buildroot}%{_liconsdir}/%{drivername}-amdcccle.png
%else
install -m644 common/usr/share/icons/ccc_large.xpm %{buildroot}%{_liconsdir}/%{drivername}-amdcccle.xpm
install -m644 common/usr/share/icons/ccc_small.xpm %{buildroot}%{_iconsdir}/%{drivername}-amdcccle.xpm
%endif

# install libraries
install -d -m755					%{buildroot}%{_libdir}/%{drivername}
install -m755 %{archdir}/usr/X11R6/%{_lib}/libGL.so.1.2	%{buildroot}%{_libdir}/%{drivername}
/sbin/ldconfig -n					%{buildroot}%{_libdir}/%{drivername}
ln -s libGL.so.1					%{buildroot}%{_libdir}/%{drivername}/libGL.so
[ ! -x							%{buildroot}%{_libdir}/%{drivername}/libGL.so.1 ]
# ATI lib contains wrong soname, we create a wrapper
%{__cc} %{optflags} -fPIC -shared -s -o \
	%{buildroot}%{_libdir}/%{drivername}/libGL.so.1 -Wl,-soname,libGL.so.1 \
	%{buildroot}%{_libdir}/%{drivername}/libGL.so.1.2
%ifarch x86_64
install -d -m755					%{buildroot}%{_prefix}/lib/%{drivername}
install -m755 %{archdir}/usr/X11R6/lib/libGL.so.1.2	%{buildroot}%{_prefix}/lib/%{drivername}
/sbin/ldconfig -n					%{buildroot}%{_prefix}/lib/%{drivername}
ln -s libGL.so.1					%{buildroot}%{_prefix}/lib/%{drivername}/libGL.so
[ ! -x							%{buildroot}%{_prefix}/lib/%{drivername}/libGL.so.1 ]
# ATI lib contains wrong soname, we create a wrapper
%{__cc} %{optflags} -m32 -fPIC -shared -s -o \
	%{buildroot}%{_prefix}/lib/%{drivername}/libGL.so.1 -Wl,-soname,libGL.so.1 \
	%{buildroot}%{_prefix}/lib/%{drivername}/libGL.so.1.2
%endif
%if !%{atibuild}
install -m755 fglrx_tools/lib/fglrx_gamma/libfglrx_gamma.so.1.0 %{buildroot}%{_libdir}/%{drivername}
%else
install -m755 %{archdir}/usr/X11R6/%{_lib}/libfglrx_gamma.so.1.0 %{buildroot}%{_libdir}/%{drivername}
%endif
install -m755 %{archdir}/usr/X11R6/%{_lib}/libfglrx_pp.so.1.0 %{buildroot}%{_libdir}/%{drivername}
install -m755 %{archdir}/usr/X11R6/%{_lib}/libfglrx_dm.so.1.0 %{buildroot}%{_libdir}/%{drivername}
install -m755 %{archdir}/usr/X11R6/%{_lib}/libfglrx_tvout.so.1.0 %{buildroot}%{_libdir}/%{drivername}
/sbin/ldconfig -n					%{buildroot}%{_libdir}/%{drivername}
ln -s libfglrx_gamma.so.1.0				%{buildroot}%{_libdir}/%{drivername}/libfglrx_gamma.so
ln -s libfglrx_pp.so.1.0				%{buildroot}%{_libdir}/%{drivername}/libfglrx_pp.so
ln -s libfglrx_dm.so.1.0				%{buildroot}%{_libdir}/%{drivername}/libfglrx_dm.so
ln -s libfglrx_tvout.so.1.0				%{buildroot}%{_libdir}/%{drivername}/libfglrx_tvout.so
%if !%{atibuild}
install -m644 fglrx_tools/lib/fglrx_gamma/libfglrx_gamma.a %{buildroot}%{_libdir}/%{drivername}
%else
install -m755 %{archdir}/usr/X11R6/%{_lib}/libfglrx_gamma.a %{buildroot}%{_libdir}/%{drivername}
%endif
install -m644 %{archdir}/usr/X11R6/%{_lib}/libfglrx_pp.a %{buildroot}%{_libdir}/%{drivername}
install -m644 %{archdir}/usr/X11R6/%{_lib}/libfglrx_dm.a %{buildroot}%{_libdir}/%{drivername}
install -m644 %{archdir}/usr/X11R6/%{_lib}/libfglrx_tvout.a %{buildroot}%{_libdir}/%{drivername}

# install X.org files
install -d -m755					%{buildroot}%{ati_driversdir}
install -m755 %{xverdir}/usr/X11R6/%{_lib}/modules/drivers/*.so* %{buildroot}%{ati_driversdir}
install -d -m755					%{buildroot}%{ati_modulesdir}/linux
install -m755 %{xverdir}/usr/X11R6/%{_lib}/modules/linux/*.so* %{buildroot}%{ati_modulesdir}/linux
install -m755 %{xverdir}/usr/X11R6/%{_lib}/modules/*.so	%{buildroot}%{ati_modulesdir}
%if %{mdkversion} >= 200800
install -d -m755	%{buildroot}%{xorg_libdir}/modules/drivers
touch			%{buildroot}%{xorg_libdir}/modules/drivers/fglrx_drv.so
install -d -m755	%{buildroot}%{xorg_libdir}/modules/linux
touch			%{buildroot}%{xorg_libdir}/modules/linux/libfglrxdrm.so
touch			%{buildroot}%{xorg_libdir}/modules/glesx.so
%endif
install -m644 %{xverdir}/usr/X11R6/%{_lib}/modules/*.a	%{buildroot}%{xorg_libdir}/modules

# etc files
install -d -m755		%{buildroot}%{ati_sysconfdir}
install -m644 common/etc/ati/*	%{buildroot}%{ati_sysconfdir}
chmod 0755			%{buildroot}%{ati_sysconfdir}/*.sh
%if %{mdkversion} >= 200800
install -d -m755		%{buildroot}%{_sysconfdir}/ati
%endif

# ld.so.conf
install -d -m755			%{buildroot}%{ld_so_conf_dir}
echo "%{_libdir}/%{drivername}" >	%{buildroot}%{ld_so_conf_dir}/%{ld_so_conf_file}
%ifarch x86_64
echo "%{_prefix}/lib/%{drivername}" >>	%{buildroot}%{ld_so_conf_dir}/%{ld_so_conf_file}
%endif
%if %{mdkversion} >= 200700
touch					%{buildroot}%{_sysconfdir}/ld.so.conf.d/GL.conf
%endif

# modprobe.conf
%if %{mdkversion} >= 200800
install -d -m755			%{buildroot}%{_sysconfdir}/modprobe.d
install -d -m755			%{buildroot}%{_sysconfdir}/fglrx-hd2000-mdv
touch					%{buildroot}%{_sysconfdir}/modprobe.d/fglrx-hd2000.conf
echo "alias fglrx fglrx-hd2000" >	%{buildroot}%{_sysconfdir}/fglrx-hd2000-mdv/modprobe.conf
%endif

%if %{mdkversion} >= 200800
%pre -n %{driverpkgname}
# Handle pre-alternatives /etc/ati directory
if [ -d %{_sysconfdir}/ati -a ! -L %{_sysconfdir}/ati -a ! -d %{_sysconfdir}/fglrx ]; then
	mv %{_sysconfdir}/ati %{_sysconfdir}/fglrx || :
fi
%endif

# Prevent problems with rpm removing files in /etc/ati or in /usr/share/ati
# after %post by using %posttrans:
%posttrans -n %{driverpkgname}
%if %{mdkversion} >= 200700
%{_sbindir}/update-alternatives \
	--install %{_sysconfdir}/ld.so.conf.d/GL.conf gl_conf %{ld_so_conf_dir}/%{ld_so_conf_file} %{priority} \
%if %{mdkversion} >= 200800
	--slave %{_libdir}/xorg/modules/extensions/libglx.so libglx %{_libdir}/xorg/modules/extensions/standard/libglx.so \
	--slave %{_sysconfdir}/ati ati_etcdir %{ati_sysconfdir} \
	--slave %{_datadir}/ati ati_datadir %{_datadir}/%{drivername} \
	--slave %{_bindir}/aticonfig aticonfig %{ati_bindir}/aticonfig \
	--slave %{_bindir}/amdcccle amdcccle %{ati_bindir}/amdcccle \
	--slave %{_bindir}/fgl_glxgears fgl_glxgears %{ati_bindir}/fgl_glxgears \
	--slave %{_bindir}/fglrx_xgamma fglrx_xgamma %{ati_bindir}/fglrx_xgamma \
	--slave %{_bindir}/fglrxinfo fglrxinfo %{ati_bindir}/fglrxinfo \
	--slave %{_sbindir}/atieventsd atieventsd %{ati_sbindir}/atieventsd \
	--slave %{_sbindir}/atigetsysteminfo.sh atigetsysteminfo.sh %{ati_sbindir}/atigetsysteminfo.sh \
	--slave %{xorg_libdir}/modules/drivers/fglrx_drv.so fglrx_drv.so %{ati_driversdir}/fglrx_drv.so \
	--slave %{xorg_libdir}/modules/linux/libfglrxdrm.so libfglrxdrm.so %{ati_modulesdir}/linux/libfglrxdrm.so \
	--slave %{xorg_libdir}/modules/glesx.so glesx.so %{ati_modulesdir}/glesx.so \
	--slave %{_datadir}/applications/mandriva-amdcccle.desktop mandriva-amdcccle.desktop %{ati_desktopdir}/mandriva-amdcccle.desktop \
	--slave %{_sysconfdir}/modprobe.d/fglrx-hd2000.conf fglrx-hd2000.conf %{_sysconfdir}/fglrx-hd2000-mdv/modprobe.conf
%endif
# empty line so that /sbin/ldconfig is not passed to update-alternatives
%endif
/sbin/ldconfig
%_post_service atieventsd-hd2000

%preun -n %{driverpkgname}
%_preun_service atieventsd-hd2000

%postun -n %{driverpkgname}
%if %{mdkversion} >= 200700
if [ ! -f %{ld_so_conf_dir}/%{ld_so_conf_file} ]; then
  %{_sbindir}/update-alternatives --remove gl_conf %{ld_so_conf_dir}/%{ld_so_conf_file}
fi
%endif
/sbin/ldconfig

%post -n %{drivername}-control-center
%{update_menus}

%postun -n %{drivername}-control-center
%{clean_menus}

%post -n dkms-%{drivername}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{drivername} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{drivername} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{drivername} -v %{version}-%{release} --force

# rmmod any old driver if present and not in use (e.g. by X)
rmmod fglrx > /dev/null 2>&1 || true

%preun -n dkms-%{drivername}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{drivername} -v %{version}-%{release} --all

# rmmod any old driver if present and not in use (e.g. by X)
rmmod fglrx > /dev/null 2>&1 || true

%clean
rm -rf %{buildroot}

%files -n %{driverpkgname}
%defattr(-,root,root)
%doc README.install.urpmi README.manual-setup
%doc common/usr/share/doc/fglrx/*

%if %{mdkversion} >= 200700
# 2007.0,2007.1,2008.0
%ghost %{_sysconfdir}/ld.so.conf.d/GL.conf
%dir %{_sysconfdir}/ld.so.conf.d/GL
%{_sysconfdir}/ld.so.conf.d/GL/%{ld_so_conf_file}
%if %{mdkversion} >= 200800
# 2008.0
%dir %{_sysconfdir}/fglrx-hd2000-mdv
%{_sysconfdir}/fglrx-hd2000-mdv/modprobe.conf
%ghost %{_sysconfdir}/modprobe.d/fglrx-hd2000.conf
%endif
%else
# 2006.0
%config(noreplace) %{_sysconfdir}/ld.so.conf.d/ati.conf
%endif

%dir %{ati_sysconfdir}
%{ati_sysconfdir}/control
%{ati_sysconfdir}/signature
%config(noreplace) %{ati_sysconfdir}/atiogl.xml
%{ati_sysconfdir}/logo.xbm.example
%{ati_sysconfdir}/logo_mask.xbm.example
%config %{ati_sysconfdir}/authatieventsd.sh
%if %{mdkversion} >= 200800
%ghost %dir %{_sysconfdir}/ati
%endif

%{_initrddir}/atieventsd-hd2000

%{ati_sbindir}/atieventsd
%{ati_sbindir}/atigetsysteminfo.sh
%if %{mdkversion} >= 200800
%ghost %{_sbindir}/atieventsd
%ghost %{_sbindir}/atigetsysteminfo.sh
%endif

%{ati_bindir}/aticonfig
%{ati_bindir}/fgl_glxgears
%{ati_bindir}/fglrxinfo
%{ati_bindir}/fglrx_xgamma
%if %{mdkversion} >= 200800
%dir %{ati_bindir}
%ghost %{_bindir}/aticonfig
%ghost %{_bindir}/fgl_glxgears
%ghost %{_bindir}/fglrxinfo
%ghost %{_bindir}/fglrx_xgamma
%endif

%{ati_driversdir}/fglrx_drv.so
%{ati_modulesdir}/linux/libfglrxdrm.so
%{ati_modulesdir}/glesx.so
%if %{mdkversion} >= 200800
%dir %{ati_modulesdir}
%dir %{ati_driversdir}
%dir %{ati_modulesdir}/linux
%ghost %{xorg_libdir}/modules/drivers/fglrx_drv.so
%ghost %{xorg_libdir}/modules/linux/libfglrxdrm.so
%ghost %{xorg_libdir}/modules/glesx.so
%endif

%dir %{_libdir}/%{drivername}
%{_libdir}/%{drivername}/libGL.so.1
%{_libdir}/%{drivername}/libGL.so.1.*
%ifarch x86_64
%dir %{_prefix}/lib/%{drivername}
%{_prefix}/lib/%{drivername}/libGL.so.1
%{_prefix}/lib/%{drivername}/libGL.so.1.*
%endif

%{_libdir}/%{drivername}/libfglrx_gamma.so.1*
%{_libdir}/%{drivername}/libfglrx_pp.so.1*
%{_libdir}/%{drivername}/libfglrx_dm.so.1*
%{_libdir}/%{drivername}/libfglrx_tvout.so.1*

%files -n %{drivername}-control-center
%defattr(-,root,root)
%{ati_bindir}/amdcccle
%if %{mdkversion} >= 200800
%ghost %{_bindir}/amdcccle
%ghost %dir %{_datadir}/ati
%endif
%{ati_datadir}
%if %{atibuild}
%{_iconsdir}/%{drivername}-amdcccle.xpm
%{_liconsdir}/%{drivername}-amdcccle.xpm
%else
%{_miconsdir}/%{drivername}-amdcccle.png
%{_iconsdir}/%{drivername}-amdcccle.png
%{_liconsdir}/%{drivername}-amdcccle.png
%endif
%if %{mdkversion} <= 200710
%{_datadir}/applications/mandriva-amdcccle.desktop
%else
%ghost %{_datadir}/applications/mandriva-amdcccle.desktop
%dir %{ati_desktopdir}
%{ati_desktopdir}/mandriva-amdcccle.desktop
%endif
%if %{mdkversion} <= 200600
%{_menudir}/%{drivername}-control-center
%endif

%files -n %{drivername}-devel
%defattr(-,root,root)
%{_libdir}/%{drivername}/libfglrx_gamma.a
%{_libdir}/%{drivername}/libfglrx_pp.a
%{_libdir}/%{drivername}/libfglrx_dm.a
%{_libdir}/%{drivername}/libfglrx_tvout.a
%{_libdir}/%{drivername}/libfglrx_gamma.so
%{_libdir}/%{drivername}/libfglrx_pp.so
%{_libdir}/%{drivername}/libfglrx_dm.so
%{_libdir}/%{drivername}/libfglrx_tvout.so
%{xorg_libdir}/modules/esut.a
%{xorg_includedir}/X11/extensions/fglrx_gamma.h
%dir %{_includedir}/GL
%{_includedir}/GL/*ATI.h
%{_libdir}/%{drivername}/libGL.so
%ifarch x86_64
%{_prefix}/lib/%{drivername}/libGL.so
%endif

%files -n dkms-%{drivername}
%defattr(-,root,root)
%{_usrsrc}/%{drivername}-%{version}-%{release}


%changelog
* Fri Nov 16 2007 Anssi Hannula <anssi@mandriva.org> 8.41.7-3.1mdv2008.0
+ Revision: 109166
- workaround apparent wrong SONAME in ATI libGL by creating a wrapper
  named libGL.so.1 that is linked against libGL.so.1.2

* Thu Sep 20 2007 Anssi Hannula <anssi@mandriva.org> 8.41.7-3mdv2008.0
+ Revision: 91579
- change %%post to %%posttrans to prevent more problems with rpm removing files

* Thu Sep 20 2007 Anssi Hannula <anssi@mandriva.org> 8.41.7-2mdv2008.0
+ Revision: 91421
- provide ghosts for directories as well (fixes #33809)

* Sun Sep 16 2007 Anssi Hannula <anssi@mandriva.org> 8.41.7-1mdv2008.0
+ Revision: 87758
- add conflicts with old drakx-kbd-mouse-x11 and harddrake
- 8.41.7
- create fglrx-hd2000 from fglrx
- fix suggests
- check for driver before printing anything in atieventsd initscript
- use alternatives for more files to allow co-existence with fglrx-hd2000

* Sat Sep 15 2007 Anssi Hannula <anssi@mandriva.org> 8.40.4-3mdv2008.0
+ Revision: 85915
- start atieventsd on runlevel 5 only
- fix versioned provides/obsoletes in control center subpkg
- no need to own /usr/X11R6, it is owned by x11-server-common
- drop useless fgl_glxgears man page, it was an old upstream one
  without all the correct options
- fix menu entry

* Fri Aug 31 2007 Anssi Hannula <anssi@mandriva.org> 8.40.4-2mdv2008.0
+ Revision: 76979
- drop executable perm of fglrx.spec (Charles A Edwards)
- add a note into README.install.urpmi about reconfiguring being
  unnecessary when upgrading

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Sun Aug 26 2007 Anssi Hannula <anssi@mandriva.org> 8.40.4-1mdv2008.0
+ Revision: 71697
- use alternatives for libglx.so
- update documentation
- 8.40.4
- rewrite spec
- preapply uname_r patch
- can now be built as standard rpm as well, i.e. outside ati installer
- build some tools from sources when built outside ati installer
- add patches that fix includes in some tools
- use %%{version}-%%{release} for dkms PACKAGE_VERSION
- now has a source package, named fglrx
- rename to x11-driver-video-fglrx and dkms-fglrx on cooker
- move tools to main driver package, except for amdcccle
- introduce control-center subpackage for amdcccle
- require fixed update-alternatives instead of workarounding bugs
- use generic license tag
- remove hardcoded vendor, packager, prefix tags
- adapt and simplify ati-packager.sh for new spec layout
- clean libGL.so.1 from provides (bug #28216)
- first Mandriva build with the tools enabled (bug #28094)
- better URL
- exclusivearch ix86 x86_64
- add post and preun script requires on dkms
- re-enable devel package
- do not call the next dkms step if previous fails
- own the old X11R6 directories where we are creating the compatibility
  symlink for now
- move atieventsd to the main package; the separation was not useful as it
  was required by main package
- provide png icon
- change distsuffix of the ati installer build
- do not leave temp directory behind in installer mode when rpm-build is not
  installed

